/*
 * Copyright 2014 Sam Elsharif
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package info.msxlaunchers.openmsx.launcher.ui.view.swing.component;

import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import javax.swing.JLabel;

/**
 * @since v1.2
 * @author Sam Elsharif
 *
 */
@SuppressWarnings("serial")
public class HyperLink extends JLabel
{
	public HyperLink(final String label, final String address)
	{
		super("<HTML><FONT color=\"#000099\">" + label + "</FONT></HTML>");

		setCursor(new Cursor(Cursor.HAND_CURSOR));

	    addMouseListener(new MouseListener() {
			
			@Override
			public void mouseReleased(MouseEvent arg) {}
			
			@Override
			public void mousePressed(MouseEvent arg) {}
			
			@Override
			public void mouseExited(MouseEvent arg) {}
			
			@Override
			public void mouseEntered(MouseEvent arg) {}
			
			@Override
			public void mouseClicked(MouseEvent arg)
			{
				//now bring up the default browser of the system for URL or the system default application
				Desktop desktop = Desktop.isDesktopSupported() ? Desktop.getDesktop() : null;
			    if(desktop != null && desktop.isSupported(Desktop.Action.OPEN))
			    {
			    	try
			    	{
						desktop.browse(new URI(address));
					}
			    	catch(URISyntaxException e)
			    	{
			    		//what to do?
			    	}
			    	catch(IOException e)
			    	{
			    		//what to do?
					}
			    }
			    else
			    {
			    	//the following link:
			    	// http://stackoverflow.com/questions/8258153/how-to-get-desktop-class-supported-under-linux
			    	//explains why code might get here on Linux
			    }
			}
	    });
	}
}
